TITLE case.asm: semplice programma assembly 8086

COMMENT * semplice programma che illustra come scrivere un case statement
in assembler. Mostra l'uso di istruzioni aritmetiche, di manipolazione
di bit e di controllo e l'uso di array.
*
	

STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     



DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati

I	DW	5
J	DW	4
F	DW	?

JmpTbl DW Istr1, Istr2, Istr3

INSERISCI DB LF,CR,'Inserire un numero: 0, 1 o 2',CR,LF,LF
      	  DB '$'                   ; ogni stringa deve terminare con '$'
str1	  DB LF,CR,'Ho eseguito la somma I+J',CR,LF,LF
      	  DB '$'                  
str2	  DB LF,CR,'Ho eseguito la sottrazione I-J',CR,LF,LF
      	  DB '$'                  
str3	  DB LF,CR,'Ho eseguito la somma I+1',CR,LF,LF
      	  DB '$'                  
                                
DATA ENDS



PRIMO	EQU 48			; codifica ASCII del carattere "0"
CR 	EQU 13          	; carriage return
LF 	EQU 10                  ; line feed
DISPLAY EQU 9		        ; DOS function call Display
KBDIN 	EQU 1                   ; DOS function call Keyboard Input



CSEG SEGMENT PUBLIC 'CODE'

CASE PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK

        PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                         
        MOV AX,SEG DATA       ; necessari 2 trasferimenti per assegnare a DS 
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito

Ins:    MOV DX,OFFSET INSERISCI   ; display messaggio di acquisizione numero
        MOV AH,DISPLAY        
        INT 21H               
	
	MOV AH,KBDIN          ; attesa carattere da tastiera (0, 1 o 2)
        INT 21H		      ; il carattere acquisito va in AL	
	
	SUB AL,PRIMO	      ; trovo il numero corrispondente al carattere acquisito
	CMP AL,0
	JL  Ins		      ; torna ad acquisire carattere se < 0
	CMP AL,2
	JG  Ins		      ; torna ad acquisire carattere se > 2

	SUB BX,BX	      ; inizializzazione di BX	
	MOV BL,AL	      ; copia nel byte meno significativo di BX indice case
	SHL BX,1	      ; moltiplica BX per 2
	JMP JmpTbl[BX]	      ; esecuzione del case

Istr1:  MOV AX,I	      ; salta qui se l'indice del case vale 0
	ADD AX,J
	MOV F,AX	      ; F=I+J
        MOV DX,OFFSET str1   
	MOV AH,DISPLAY          
    	INT 21H               
	JMP  ENDCASE
Istr2:  MOV AX,I	      ; salta qui se l'indice del case vale 1
	SUB AX,J
	MOV F,AX	      ; F=I-J
        MOV DX,OFFSET str2   
	MOV AH,DISPLAY          
   	INT 21H               
	JMP  ENDCASE
Istr3:  MOV AX,I	      ; salta qui se l'indice del case vale 2
	INC AX
	MOV F,AX	      ; F=I+1
        MOV DX,OFFSET str3   
	MOV AH,DISPLAY          
    	INT 21H               
ENDCASE: RET                   ; si restituisce il controllo al DOS
CASE ENDP
CSEG ENDS
END CASE                     
