TITLE routbios.asm: semplice programma assembly 8086

COMMENT *
	semplice programma che legge caratteri da tastiera e li mostra a video
	finche' non viene premuto il tasto CR. 
	Mostra l'utilizzo degli interrupt 10h e 16h del BIOS*

;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     
;


CSEG SEGMENT PUBLIC 'CODE'

Main PROC FAR
      ASSUME CS:CSEG,SS:STACK

        PUSH DS         ; salvataggio valore corrente di DS 
        SUB AX,AX       ; AX viene azzerato, e
        PUSH AX         ; posto nello stack 
   
Ciclo:	MOV AH,0	; codice AH = 0 per leggere carattere da tastiera
	INT 16h		; interrupt BIOS della tastiera, il carattere letto va il AL
	CMP AL,0	; carattere speciale?
	JZ  Ciclo	; se cosi' torna a leggere carattere

			; FA L'ECO DEL CARATTERE LETTO
	MOV AH,0Eh	; codice AH = 0Eh per scrivere carattere su video (che  in AL)
	INT 10H		; interrupt BIOS del video

	CMP AL, 0dh	; carriage return?
	JNE Ciclo	; torna a leggere carattere se non CR	

        RET             ; si restituisce il controllo al DOS
	
Main ENDP

CSEG ENDS

END Main                     
