TITLE segmenti.asm: semplice programma assembly 8086

COMMENT *
Programma per valutare l'uso dei registri segmento, dimostrando che la 
direttiva ASSUME non cambia i valori dei registri segmento.
*


STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     


DATA1 SEGMENT PUBLIC 'DATA'     ; definizione segmento dati 1
   V1 DB  1                     ; variabile 1 di valore 1  
DATA1 ENDS

DATA2 SEGMENT PUBLIC 'DATA'     ; definizione segmento dati 2
   V2 DB  2                     ; variabile 2 di valore 2  
DATA2 ENDS



CSEG SEGMENT PUBLIC 'CODE'

PRIMO PROC FAR
      ASSUME CS:CSEG,DS:DATA1,ES:DATA2,SS:STACK

;;;;;;;;;;;;;;;;;;;;;;;;
        PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                              ; Quando con la RET si restituisce il
                              ; controllo al DOS, questo riparte da DS:0000. 
                              ; La RET effettua automaticamente il POP 
                              ; dei due registri
;;;;;;;;;;;;;;;;;;;;;;;;

        MOV AX,SEG DATA1      ; 
        MOV DS,AX             ; assegno a DS il valore relativo a segmento dati 1
	MOV AX,SEG DATA2
	MOV ES,AX             ; assegno a ES il valore relativo a segmento dati 2
	
	SUB AX,AX	      ; azzera AX
	MOV AL,V2	      ; carica in AL il valore di V2 = 2
	SUB AL,AL	      ; azzera AL
	MOV AL,DS:V2	      ; carica in AL il valore di V2 = 2, ma utilizzando
			      ; DS come segmento e quindi offset rispetto all'indirizzo di segmento 1
	SUB AL,AL	      ; azzera AL

	ASSUME DS:DATA2	      ; ora l'assemblatore pensa che DS si riferisca a segmento dati 2
	ASSUME ES:DATA1       ; ed ES al segmento dati 1. MA I VALORI NON SONO CAMBIATI!
	MOV AL,V1	      ; e quindi per V1 usa ES che punta a segmento dati 2 : AL=2
	MOV AL,V2	      ; mentre in questo caso AL=1
 
;;;;;;;;;;;;;;;;;;;;;;;;
        RET                   ; si restituisce il controllo al DOS
	
PRIMO ENDP
CSEG ENDS
END PRIMO                     
