TITLE spazi2.asm: semplice programma assembly 8086

COMMENT * semplice programma che visualizza 20 righe di 40
spazi su video. Mostra l'uso di procedure e macro. *

;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     
;

DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati
  
CIAO  DB 'Ciao!!!!',LF,LF,LF,'$' 
               
DATA ENDS

;dichiarazioni di costanti
CR 	EQU 13          	; carriage return
LF 	EQU 10                  ; line feed
SPAZIO	EQU 20H			; codice ascii dello spazio
DISPLAY_CHAR EQU 2		; codice funzione per visualizzare carattere
DISPLAY_STRING EQU 9		; codice funzione per visualizzare stringa

;dichiarazioni di macro
PutChar		MACRO char
		MOV DL, char	
		MOV AH, DISPLAY_CHAR
		INT 21H  
		ENDM
;
PutString	MACRO text
		MOV DX, OFFSET text   
		MOV AH, DISPLAY_STRING
		INT 21H  
		ENDM

CSEG SEGMENT PUBLIC 'CODE'
  ASSUME CS:CSEG,DS:DATA,SS:STACK

; programma principale
Main PROC FAR
        PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                              
        MOV AX,SEG DATA       ; necessari 2 trasferimenti per assegnare a DS 
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito

	MOV CX,20	      ; inizializza contatore a 20 (num. righe da visualizzare)
Loop0:	PUSH CX		      ; salvataggio registro prima della chiamata di procedura
	CALL PrintSpaces      ; chiamata procedura per la visualizzazione di una riga
	POP CX		      ; ripristino contatore CX
	PutChar CR	      ; macro per visualizzare CR
	PutChar LF	      ; macro per visualizzare LF
	LOOP Loop0 

	PutString CIAO	      ; macro per visualizzare saluto	
	RET                   ; si restituisce il controllo al DOS
Main ENDP

; procedura PrintSpaces per la visualizzazione di una riga di spazi
PrintSpaces	PROC NEAR
		MOV CX, 40
PSLoop:		PutChar SPAZIO
		LOOP PSLoop
		RET
PrintSpaces	ENDP


CSEG ENDS
END Main                     
