TITLE stringhe.asm: semplice programma assembly 8086

COMMENT * semplice programma che copia il contenuto di una stringa 
in un'altra stringa eliminando gli spazi. Viene cosi' mostrato 
l'uso delle istruzioni loop e loopne.  
*

	
;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     
;



DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati

ascii_str1	DB CR,'Ciao a tutti: sono una prova',CR,LF,'$'                  
ascii_str2	DB 30 DUP (?)
                  
DATA ENDS



LENGTH	EQU 30			; lunghezza della stringa ascii_str1
SPAZIO	EQU 20h			; codifica ASCII del carattere 'spazio'
CR 	EQU 13          	; carriage return
LF 	EQU 10                  ; line feed
DISPLAY EQU 9		        ; DOS function call Display



CSEG SEGMENT PUBLIC 'CODE'
STRINGHE PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK

        PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                              ; Quando con la RET si restituisce il
                              ; controllo al DOS, questo riparte da DS:0000. 
                              ; La RET effettua automaticamente il POP 
                              ; dei due registri

        MOV AX,SEG DATA       ; necessari 2 trasferimenti per assegnare a DS 
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito

        MOV DX,OFFSET ascii_str1   ; display stringa originale
        MOV AH,DISPLAY        
        INT 21H               
	
	MOV CX, LENGTH 		; pone la lunghezza della stringa in CX
	MOV SI, -1		; inizializza indice di ascii_str1
	MOV DI, SI		; inizializza indice di ascii_str2
	MOV AL, SPAZIO		; pone il AL il codice ascii dello spazio

Next:	INC SI
	INC DI
	MOV BL, ascii_str1[SI]
	MOV ascii_str2[DI], BL  ; copia il car corrente in ascii_str2
	CMP AL,ascii_str1[SI]	; confronta se spazio
	LOOPNE	Next	; continua se non  spazio e non ha finito (CX non zero)
	DEC DI		; decrementa DI per riscrivere il carattere corrente (<> da spazio)
	INC CX		; ripristina CX per la prossima istruzione loop
	LOOP Next	; finisce solo se CX  zero
		
	INC DI
	MOV ascii_str2[DI], '$'    ; aggiungi '$' in fondo alla stringa da visualizzare 	
        MOV DX,OFFSET ascii_str2   ; display stringa senza spazi
	MOV AH,DISPLAY          
    	INT 21H               

       RET                   ; si restituisce il controllo al DOS

STRINGHE ENDP

CSEG ENDS

END STRINGHE                     
